/***************************************************************************
                          gsmstring.cpp  -  description
                             -------------------
    begin                : Thu Feb 8 2001
    copyright            : (C) 2001 by Matthias Welwarsky
    email                : matze@stud.fbi.fh-darmstadt.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "gsmstring.h"

GSMString::GSMString(){
}

GSMString::GSMString(const QString& text) {
	gsmEncode(text);
}

GSMString::~GSMString(){
}

/** encodes a QString into a GSMString by escaping all special characters of the argument. */
void GSMString::gsmEncode(const QString& text){
	int i;

	for (i = 0; i < text.length(); i++) {
		switch (text[i]) {
		default:
			*this += text[i];
			break;
		case '"':
			*this += "\\22";
			break;
		case 0x08:
			*this += "\\08";
			break;
		case '@':
			*this += "\\00";
			break;
		case '':
			*this += '~';
			break;
		case '':
			*this += '|';
			break;
		case '':
			*this += '[';
			break;
		case '':
			*this += '{';
			break;
		case '':
			*this += "\\5c";
			break;
		case '':
			*this += '^';
			break;
		}
	}
}

GSMString& GSMString::operator=(const QString& text) {
	if (!isEmpty())
		*this = 0;
	gsmEncode(text);
}

QString GSMString::toQString() {
	QString result;
	int i;

	for (int i = 0; i < length(); i++) {
		switch (*this[i]) {
		default:
			result += *this[i];
			break;
		case '~':
			result += '';
			break;
		case '|':
			result += '';
			break;
		case '[':
			result += '';
			break;
		case '{':
			result += '';
			break;
		case '\\':
			result += '';
			break;
		case '^':
			result += '';
			break;
		}
	}
	return result;	
}