/***************************************************************************
                          phonecontrol.h  -  description
                             -------------------
    begin                : Wed Jan 17 2001
    copyright            : (C) 2001 by Matthias Welwarsky
    email                : matze@stud.fbi.fh-darmstadt.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef PHONECONTROL_H
#define PHONECONTROL_H

#include <qwidget.h>

/**abstract base class of all phone controls
  *@author Matthias Welwarsky
  */

class PhoneControl : public QWidget  {
   Q_OBJECT

public:
	PhoneControl(QWidget *parent=0, const char *name=0);
	virtual ~PhoneControl();

    /** stops a phone control, must be called when the control is lowered.
     *  pure virtual methon, must be reimplemented in the derived class */
    virtual void stopControl() = 0;

    /** start a phone control, must be called when control widget is made visible.
     *  pure virtual method, must be reimplemented in the derived class */
  	virtual void startControl() = 0;

 	/** called by the MessageDispatcher to deliver messages from the mobile phone
     *  pure virtual method, must be reimplemented in the derived class */
  	virtual void deliverMessage(QString) = 0;

};

#endif
